/*		Essai de programmation PSIGPAUSE		*/

typedef unsigned long	ulong;
typedef unsigned short	ushort;
typedef short int		WORD;

#include <stdio.h>
#include <stdlib.h>
#include <tos.h>

#include <mintbind.h>
#include <signal.h>

#define	even(i) ((2*(i/2) == i) ? 1 : 0)

void nothing(void);
void aff_long(ulong);
void action_fils(void);

WORD pid;

void main()
{
	ulong mask = 0;
	
	mask = -1L - (1L << SIGUSR1);
	printf("mask calcul = "); 
	aff_long(mask);
	
	Psignal(SIGUSR1, nothing);	/* debloque le signal	*/

	for(;;)
	{
		printf("attente avec mask = "); 
		aff_long(mask);
		Psigpause(mask); 
		printf("F: synchronis...\n\n");
	}	
}

void nothing(){}

void action_fils()
{
	printf("msg reu\n");
}

void aff_long(ulong x)
{
	int i;

	for(i=0; i<32; i++) { 		
		if (even(x)) printf("0"); else printf("1"); 
		x /= 2;
	}
	printf("\n");
}
